diff -urN ../VisualBoyAdvance-1.7.2/src/GBA.cpp ./src/GBA.cpp
--- ../VisualBoyAdvance-1.7.2/src/GBA.cpp	2004-05-13 23:37:59 +0900
+++ ./src/GBA.cpp	2006-08-25 23:13:38 +0900
@@ -2651,54 +3008,54 @@
     break;
   case 0x204:
     {
-      int i;
       memoryWait[0x0e] = memoryWaitSeq[0x0e] = gamepakRamWaitState[value & 3];
       
       if(!speedHack) {
-        memoryWait[0x08] = memoryWait[0x09] = gamepakWaitState[(value >> 2) & 7];
+        memoryWait[0x08] = memoryWait[0x09] = gamepakWaitState[(value >> 2) & 3];
         memoryWaitSeq[0x08] = memoryWaitSeq[0x09] =
-          gamepakWaitState0[(value >> 2) & 7];
+          gamepakWaitState0[(value >> 4) & 1];
         
-        memoryWait[0x0a] = memoryWait[0x0b] = gamepakWaitState[(value >> 5) & 7];
+        memoryWait[0x0a] = memoryWait[0x0b] = gamepakWaitState[(value >> 5) & 3];
         memoryWaitSeq[0x0a] = memoryWaitSeq[0x0b] =
-          gamepakWaitState1[(value >> 5) & 7];
+          gamepakWaitState1[(value >> 7) & 1];
         
-        memoryWait[0x0c] = memoryWait[0x0d] = gamepakWaitState[(value >> 8) & 7];
+        memoryWait[0x0c] = memoryWait[0x0d] = gamepakWaitState[(value >> 8) & 3];
         memoryWaitSeq[0x0c] = memoryWaitSeq[0x0d] =
-          gamepakWaitState2[(value >> 8) & 7];
+          gamepakWaitState2[(value >> 10) & 1];
       } else {
-        memoryWait[0x08] = memoryWait[0x09] = 4;
-        memoryWaitSeq[0x08] = memoryWaitSeq[0x09] = 2;
+        memoryWait[0x08] = memoryWait[0x09] = 3;
+        memoryWaitSeq[0x08] = memoryWaitSeq[0x09] = 1;
         
-        memoryWait[0x0a] = memoryWait[0x0b] = 4;
-        memoryWaitSeq[0x0a] = memoryWaitSeq[0x0b] = 4;
+        memoryWait[0x0a] = memoryWait[0x0b] = 3;
+        memoryWaitSeq[0x0a] = memoryWaitSeq[0x0b] = 1;
         
-        memoryWait[0x0c] = memoryWait[0x0d] = 4;
-        memoryWaitSeq[0x0c] = memoryWaitSeq[0x0d] = 8;
+        memoryWait[0x0c] = memoryWait[0x0d] = 3;
+        memoryWaitSeq[0x0c] = memoryWaitSeq[0x0d] = 1;
       }
-      for(i = 0; i < 16; i++) {
-        memoryWaitFetch32[i] = memoryWait32[i] = memoryWait[i] *
-          (memory32[i] ? 1 : 2);
-        memoryWaitFetch[i] = memoryWait[i];
+         
+      for(int i = 8; i < 15; i++) {
+        memoryWait32[i] = memoryWait[i] + memoryWaitSeq[i] + 1;
+        memoryWaitSeq32[i] = memoryWaitSeq[i]*2 + 1;
       }
-      memoryWaitFetch32[3] += 1;
-      memoryWaitFetch32[2] += 3;
-      
-      if(value & 0x4000) {
-        for(i = 8; i < 16; i++) {
-          memoryWaitFetch32[i] = 2*cpuMemoryWait[i];
-          memoryWaitFetch[i] = cpuMemoryWait[i];
-        }
+
+      if((value & 0x4000) == 0x4000) {
+        busPrefetchEnable = true;
+        busPrefetch = false;
+        busPrefetchCount = 0;
+      } else {
+        busPrefetchEnable = false;
+        busPrefetch = false;
+        busPrefetchCount = 0;
       }
-      UPDATE_REG(0x204, value);
+      UPDATE_REG(0x204, value & 0x7FFF);
+
     }
     break;
   case 0x208:
     IME = value & 1;
     UPDATE_REG(0x208, IME);
-    if((IME & 1) && (IF & IE) && armIrqEnable) {
-      CPU_BREAK_LOOP_2;
-    }
+    if ((IME & 1) && (IF & IE) && armIrqEnable)
+      cpuNextEvent = cpuTotalTicks;
     break;
   case 0x300:
     if(value != 0)
@@ -2711,6 +3068,65 @@
   }
 }
 
+void applyTimer ()
+{
+  if (timerOnOffDelay & 1)
+  {
+    timer0ClockReload = TIMER_TICKS[timer0Value & 3];        
+    if(!timer0On && (timer0Value & 0x80)) {
+      // reload the counter
+      TM0D = timer0Reload;      
+      timer0Ticks = (0x10000 - TM0D) << timer0ClockReload;
+      UPDATE_REG(0x100, TM0D);
+    }
+    timer0On = timer0Value & 0x80 ? true : false;
+    TM0CNT = timer0Value & 0xC7;
+    UPDATE_REG(0x102, TM0CNT);
+    //    CPUUpdateTicks();
+  }
+  if (timerOnOffDelay & 2)
+  {
+    timer1ClockReload = TIMER_TICKS[timer1Value & 3];        
+    if(!timer1On && (timer1Value & 0x80)) {
+      // reload the counter
+      TM1D = timer1Reload;      
+      timer1Ticks = (0x10000 - TM1D) << timer1ClockReload;
+      UPDATE_REG(0x104, TM1D);
+    }
+    timer1On = timer1Value & 0x80 ? true : false;
+    TM1CNT = timer1Value & 0xC7;
+    UPDATE_REG(0x106, TM1CNT);
+  }
+  if (timerOnOffDelay & 4)
+  {
+    timer2ClockReload = TIMER_TICKS[timer2Value & 3];        
+    if(!timer2On && (timer2Value & 0x80)) {
+      // reload the counter
+      TM2D = timer2Reload;      
+      timer2Ticks = (0x10000 - TM2D) << timer2ClockReload;
+      UPDATE_REG(0x108, TM2D);
+    }
+    timer2On = timer2Value & 0x80 ? true : false;
+    TM2CNT = timer2Value & 0xC7;
+    UPDATE_REG(0x10A, TM2CNT);
+  }
+  if (timerOnOffDelay & 8)
+  {
+    timer3ClockReload = TIMER_TICKS[timer3Value & 3];        
+    if(!timer3On && (timer3Value & 0x80)) {
+      // reload the counter
+      TM3D = timer3Reload;      
+      timer3Ticks = (0x10000 - TM3D) << timer3ClockReload;
+      UPDATE_REG(0x10C, TM3D);
+    }
+    timer3On = timer3Value & 0x80 ? true : false;
+    TM3CNT = timer3Value & 0xC7;
+    UPDATE_REG(0x10E, TM3CNT);
+  }
+  cpuNextEvent = CPUUpdateTicks();
+  timerOnOffDelay = 0;
+}
+
 void CPUWriteHalfWord(u32 address, u16 value)
 {
 #ifdef DEV_VERSION
@@ -2726,38 +3142,58 @@
   
   switch(address >> 24) {
   case 2:
-#ifdef SDL
+#ifdef BKPT_SUPPORT
     if(*((u16 *)&freezeWorkRAM[address & 0x3FFFE]))
-      cheatsWriteHalfWord((u16 *)&workRAM[address & 0x3FFFE],
-                          value,
-                          *((u16 *)&freezeWorkRAM[address & 0x3FFFE]));
+      cheatsWriteHalfWord(address & 0x203FFFE,
+                          value);
     else
 #endif
       WRITE16LE(((u16 *)&workRAM[address & 0x3FFFE]),value);
     break;
   case 3:
-#ifdef SDL
+#ifdef BKPT_SUPPORT
     if(*((u16 *)&freezeInternalRAM[address & 0x7ffe]))
-      cheatsWriteHalfWord((u16 *)&internalRAM[address & 0x7ffe],
-                          value,
-                          *((u16 *)&freezeInternalRAM[address & 0x7ffe]));
+      cheatsWriteHalfWord(address & 0x3007ffe,
+                          value);
     else
 #endif
       WRITE16LE(((u16 *)&internalRAM[address & 0x7ffe]), value);
     break;    
   case 4:
-    CPUUpdateRegister(address & 0x3fe, value);
+    if(address < 0x4000400)
+      CPUUpdateRegister(address & 0x3fe, value);
+    else goto unwritable;
     break;
   case 5:
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezePRAM[address & 0x03fe]))
+      cheatsWriteHalfWord(address & 0x70003fe,
+                          value);
+    else
+#endif
     WRITE16LE(((u16 *)&paletteRAM[address & 0x3fe]), value);
     break;
   case 6:
-    if(address & 0x10000)
-      WRITE16LE(((u16 *)&vram[address & 0x17ffe]), value);
+    address = (address & 0x1fffe);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+        return;
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezeVRAM[address]))
+      cheatsWriteHalfWord(address + 0x06000000,
+                          value);
     else
-      WRITE16LE(((u16 *)&vram[address & 0x1fffe]), value);
+#endif
+    WRITE16LE(((u16 *)&vram[address]), value); 
     break;
   case 7:
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezeOAM[address & 0x03fe]))
+      cheatsWriteHalfWord(address & 0x70003fe,
+                          value);
+    else
+#endif
     WRITE16LE(((u16 *)&oam[address & 0x3fe]), value);
     break;
   case 8:
@@ -2797,99 +3233,113 @@
 {
   switch(address >> 24) {
   case 2:
-#ifdef SDL
+#ifdef BKPT_SUPPORT
       if(freezeWorkRAM[address & 0x3FFFF])
-        cheatsWriteByte(&workRAM[address & 0x3FFFF], b);
+        cheatsWriteByte(address & 0x203FFFF, b);
       else
 #endif  
         workRAM[address & 0x3FFFF] = b;
     break;
   case 3:
-#ifdef SDL
+#ifdef BKPT_SUPPORT
     if(freezeInternalRAM[address & 0x7fff])
-      cheatsWriteByte(&internalRAM[address & 0x7fff], b);
+      cheatsWriteByte(address & 0x3007fff, b);
     else
 #endif
       internalRAM[address & 0x7fff] = b;
     break;
   case 4:
-    switch(address & 0x3FF) {
-    case 0x301:
-      if(b == 0x80)
-        stopState = true;
-      holdState = 1;
-      holdType = -1;
-      break;
-    case 0x60:
-    case 0x61:
-    case 0x62:
-    case 0x63:
-    case 0x64:
-    case 0x65:
-    case 0x68:
-    case 0x69:
-    case 0x6c:
-    case 0x6d:
-    case 0x70:
-    case 0x71:
-    case 0x72:
-    case 0x73:
-    case 0x74:
-    case 0x75:
-    case 0x78:
-    case 0x79:
-    case 0x7c:
-    case 0x7d:
-    case 0x80:
-    case 0x81:
-    case 0x84:
-    case 0x85:
-    case 0x90:
-    case 0x91:
-    case 0x92:
-    case 0x93:
-    case 0x94:
-    case 0x95:
-    case 0x96:
-    case 0x97:
-    case 0x98:
-    case 0x99:
-    case 0x9a:
-    case 0x9b:
-    case 0x9c:
-    case 0x9d:
-    case 0x9e:
-    case 0x9f:      
-      soundEvent(address&0xFF, b);
+    if(address < 0x4000400) {
+      switch(address & 0x3FF) {
+      case 0x301:
+	if(b == 0x80)
+	  stopState = true;
+	holdState = 1;
+	holdType = -1;
+  cpuNextEvent = cpuTotalTicks;
+	break;
+      case 0x60:
+      case 0x61:
+      case 0x62:
+      case 0x63:
+      case 0x64:
+      case 0x65:
+      case 0x68:
+      case 0x69:
+      case 0x6c:
+      case 0x6d:
+      case 0x70:
+      case 0x71:
+      case 0x72:
+      case 0x73:
+      case 0x74:
+      case 0x75:
+      case 0x78:
+      case 0x79:
+      case 0x7c:
+      case 0x7d:
+      case 0x80:
+      case 0x81:
+      case 0x84:
+      case 0x85:
+      case 0x90:
+      case 0x91:
+      case 0x92:
+      case 0x93:
+      case 0x94:
+      case 0x95:
+      case 0x96:
+      case 0x97:
+      case 0x98:
+      case 0x99:
+      case 0x9a:
+      case 0x9b:
+      case 0x9c:
+      case 0x9d:
+      case 0x9e:
+      case 0x9f:      
+	soundEvent(address&0xFF, b);
+	break;
+      default:
+	if(address & 1)
+	  CPUUpdateRegister(address & 0x3fe,
+			    ((READ16LE(((u16 *)&ioMem[address & 0x3fe])))
+			     & 0x00FF) |
+			    b<<8);
+	else
+	  CPUUpdateRegister(address & 0x3fe,
+			    ((READ16LE(((u16 *)&ioMem[address & 0x3fe])) & 0xFF00) | b));
+      }
       break;
-    default:
-      //      if(address & 1) {
-      //        CPUWriteHalfWord(address-1, (CPUReadHalfWord(address-1)&0x00FF)|((int)b<<8));
-      //      } else
-      if(address & 1)
-        CPUUpdateRegister(address & 0x3fe,
-                          ((READ16LE(((u16 *)&ioMem[address & 0x3fe])))
-                           & 0x00FF) |
-                          b<<8);
-      else
-        CPUUpdateRegister(address & 0x3fe,
-                          ((READ16LE(((u16 *)&ioMem[address & 0x3fe])) & 0xFF00) | b));
-    }
+    } else goto unwritable;
     break;
   case 5:
     // no need to switch
     *((u16 *)&paletteRAM[address & 0x3FE]) = (b << 8) | b;
     break;
   case 6:
-    // no need to switch
-    if(address & 0x10000)
-      *((u16 *)&vram[address & 0x17FFE]) = (b << 8) | b;
-    else
-      *((u16 *)&vram[address & 0x1FFFE]) = (b << 8) | b;
+    address = (address & 0x1fffe);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+        return;
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+
+    // no need to switch 
+    // byte writes to OBJ VRAM are ignored
+    if ((address) < objTilesAddress[((DISPCNT&7)+1)>>2])
+    {
+#ifdef BKPT_SUPPORT
+      if(freezeVRAM[address])
+        cheatsWriteByte(address + 0x06000000, b);
+      else
+#endif  
+            *((u16 *)&vram[address]) = (b << 8) | b;
+    }
     break;
   case 7:
     // no need to switch
-    *((u16 *)&oam[address & 0x3FE]) = (b << 8) | b;
+    // byte writes to OAM are ignored
+    //    *((u16 *)&oam[address & 0x3FE]) = (b << 8) | b;
     break;    
   case 13:
     if(cpuEEPROMEnabled) {
@@ -2898,8 +3348,11 @@
     }
     goto unwritable;
   case 14:
-    if(!eepromInUse | cpuSramEnabled | cpuFlashEnabled) {
-      (*cpuSaveGameFunc)(address, b);
+      if (!(saveType == 5) && (!eepromInUse | cpuSramEnabled | cpuFlashEnabled)) {
+
+    //if(!cpuEEPROMEnabled && (cpuSramEnabled | cpuFlashEnabled)) { 
+
+        (*cpuSaveGameFunc)(address, b);
       break;
     }
     // default
@@ -3008,8 +3461,12 @@
   for(i = 0x304; i < 0x400; i++)
     ioReadable[i] = false;
 
-  *((u16 *)&rom[0x1fe209c]) = 0xdffa; // SWI 0xFA
-  *((u16 *)&rom[0x1fe209e]) = 0x4770; // BX LR
+  if(romSize < 0x1fe2000) {
+    *((u16 *)&rom[0x1fe209c]) = 0xdffa; // SWI 0xFA
+    *((u16 *)&rom[0x1fe209e]) = 0x4770; // BX LR
+  } else {
+    agbPrintEnable(false);
+  }
 }
 
 void CPUReset()
@@ -3028,7 +3485,7 @@
       }
   }
   rtcReset();
-  // clen registers
+  // clean registers
   memset(&reg[0], 0, sizeof(reg));
   // clean OAM
   memset(oam, 0, 0x400);
@@ -3043,7 +3500,7 @@
 
   DISPCNT  = 0x0080;
   DISPSTAT = 0x0000;
-  VCOUNT   = 0x0000;
+  VCOUNT   = (useBios && !skipBios) ? 0 :0x007E;
   BG0CNT   = 0x0000;
   BG1CNT   = 0x0000;
   BG2CNT   = 0x0000;
@@ -3132,7 +3589,7 @@
     if(useBios && !skipBios) {
       reg[15].I = 0x00000000;
       armMode = 0x13;
-      armIrqEnable = false;      
+      armIrqEnable = false;  
     } else {
       reg[13].I = 0x03007F00;
       reg[15].I = 0x08000000;
@@ -3145,6 +3602,7 @@
   armState = true;
   C_FLAG = V_FLAG = N_FLAG = Z_FLAG = false;
   UPDATE_REG(0x00, DISPCNT);
+  UPDATE_REG(0x06, VCOUNT);
   UPDATE_REG(0x20, BG2PA);
   UPDATE_REG(0x26, BG2PD);
   UPDATE_REG(0x30, BG3PA);
@@ -3169,7 +3627,7 @@
   biosProtected[2] = 0x29;
   biosProtected[3] = 0xe1;
   
-  lcdTicks = 960;
+  lcdTicks = (useBios && !skipBios) ? 1008 : 208;
   timer0On = false;
   timer0Ticks = 0;
   timer0Reload = 0;
@@ -3259,44 +3717,59 @@
     cpuFlashEnabled = true;
     cpuEEPROMEnabled = true;
     cpuEEPROMSensorEnabled = false;
+    saveType = gbaSaveType = 0;
     break;
   case 1: // EEPROM
     cpuSramEnabled = false;
     cpuFlashEnabled = false;
     cpuEEPROMEnabled = true;
     cpuEEPROMSensorEnabled = false;
+    saveType = gbaSaveType = 3;
+    // EEPROM usage is automatically detected
     break;
   case 2: // SRAM
     cpuSramEnabled = true;
     cpuFlashEnabled = false;
     cpuEEPROMEnabled = false;
     cpuEEPROMSensorEnabled = false;
-    cpuSaveGameFunc = sramWrite;
+    cpuSaveGameFunc = sramDelayedWrite; // to insure we detect the write
+    saveType = gbaSaveType = 1;
     break;
   case 3: // FLASH
     cpuSramEnabled = false;
     cpuFlashEnabled = true;
     cpuEEPROMEnabled = false;
     cpuEEPROMSensorEnabled = false;
-    cpuSaveGameFunc = flashWrite;
+    cpuSaveGameFunc = flashDelayedWrite; // to insure we detect the write
+    saveType = gbaSaveType = 2;
     break;
   case 4: // EEPROM+Sensor
     cpuSramEnabled = false;
     cpuFlashEnabled = false;
     cpuEEPROMEnabled = true;
     cpuEEPROMSensorEnabled = true;
+    // EEPROM usage is automatically detected
+    saveType = gbaSaveType = 3;
     break;
   case 5: // NONE
     cpuSramEnabled = false;
     cpuFlashEnabled = false;
     cpuEEPROMEnabled = false;
     cpuEEPROMSensorEnabled = false;
+    // no save at all
+    saveType = gbaSaveType = 5;
     break;
   } 
 
+  ARM_PREFETCH;
+
   systemSaveUpdateCounter = SYSTEM_SAVE_NOT_UPDATED;
-  
+
+  cpuDmaHack = false;
+
   lastTime = systemGetClock();
+
+  SWITicks = 0;
 }
 
 void CPUInterrupt()
@@ -3313,6 +3786,7 @@
 
   armNextPC = reg[15].I;
   reg[15].I += 4;
+  ARM_PREFETCH;
 
   //  if(!holdState)
   biosProtected[0] = 0x02;
@@ -3345,30 +3819,30 @@
 void CPULoop(int ticks)
 {  
   int clockTicks;
-  int cpuLoopTicks = 0;
   int timerOverflow = 0;
-  // variables used by the CPU core
+  // variable used by the CPU core
+  cpuTotalTicks = 0;
+  cpuBreakLoop = false;
+  cpuNextEvent = CPUUpdateTicks();
+  if(cpuNextEvent > ticks)
+    cpuNextEvent = ticks;
 
-  extCpuLoopTicks = &cpuLoopTicks;
-  extClockTicks = &clockTicks;
-  extTicks = &ticks;
 
-  cpuLoopTicks = CPUUpdateTicks();
-  if(cpuLoopTicks > ticks) {
-    cpuLoopTicks = ticks;
-    cpuSavedTicks = ticks;
-  }
-
-  if(intState) {
-    cpuLoopTicks = 5;
-    cpuSavedTicks = 5;
-  }
-  
   for(;;) {
 #ifndef FINAL_VERSION
     if(systemDebug) {
       if(systemDebug >= 10 && !holdState) {
         CPUUpdateCPSR();
+#ifdef BKPT_SUPPORT
+		if (debugger_last)
+		{
+		sprintf(buffer, "R00=%08x R01=%08x R02=%08x R03=%08x R04=%08x R05=%08x R06=%08x R07=%08x R08=%08x R09=%08x R10=%08x R11=%08x R12=%08x R13=%08x R14=%08x R15=%08x R16=%08x R17=%08x\n",
+                 oldreg[0], oldreg[1], oldreg[2], oldreg[3], oldreg[4], oldreg[5],
+                 oldreg[6], oldreg[7], oldreg[8], oldreg[9], oldreg[10], oldreg[11],
+                 oldreg[12], oldreg[13], oldreg[14], oldreg[15], oldreg[16],
+                 oldreg[17]);
+		}
+#endif
         sprintf(buffer, "R00=%08x R01=%08x R02=%08x R03=%08x R04=%08x R05=%08x R06=%08x R07=%08x R08=%08x R09=%08x R10=%08x R11=%08x R12=%08x R13=%08x R14=%08x R15=%08x R16=%08x R17=%08x\n",
                  reg[0].I, reg[1].I, reg[2].I, reg[3].I, reg[4].I, reg[5].I,
                  reg[6].I, reg[7].I, reg[8].I, reg[9].I, reg[10].I, reg[11].I,
@@ -3388,63 +3862,72 @@
 #endif
       }
     }
-#endif
+#endif /* FINAL_VERSION */
+
+    if(!holdState && !SWITicks) {
+
+      // Emulates the Cheat System (m) code
+      if((cheatsEnabled) && (mastercode) && (mastercode == armNextPC))
+      {
+        u32 joy = 0;
+        if(systemReadJoypads())
+          joy = systemReadJoypad(-1);
+        u32 ext = (joy >> 10);
+        cpuTotalTicks += cheatsCheckKeys(P1^0x3FF, ext);
+      }
+
+      if ((armNextPC & 0x0803FFFF) == 0x08020000)
+        busPrefetchCount=0x100;
 
-    if(!holdState) {
       if(armState) {
 #include "arm-new.h"
       } else {
 #include "thumb.h"
       }
-    } else {
-      clockTicks = lcdTicks;
+    } else
+      clockTicks = CPUUpdateTicks();
 
-      if(soundTicks < clockTicks)
-        clockTicks = soundTicks;
-      
-      if(timer0On && (timer0Ticks < clockTicks)) {
-        clockTicks = timer0Ticks;
-      }
-      if(timer1On && (timer1Ticks < clockTicks)) {
-        clockTicks = timer1Ticks;
-      }
-      if(timer2On && (timer2Ticks < clockTicks)) {
-        clockTicks = timer2Ticks;
-      }
-      if(timer3On && (timer3Ticks < clockTicks)) {
-        clockTicks = timer3Ticks;
-      }
-#ifdef PROFILING
-      if(profilingTicksReload != 0) {
-        if(profilingTicks < clockTicks) {
-          clockTicks = profilingTicks;
-        }
+    cpuTotalTicks += clockTicks;
+
+
+    if(cpuTotalTicks >= cpuNextEvent) {
+      int remainingTicks = cpuTotalTicks - cpuNextEvent;
+
+      if (SWITicks)
+      {
+        SWITicks-=clockTicks;
+        if (SWITicks<0)
+          SWITicks = 0;
       }
-#endif
-    }
+
+      clockTicks = cpuNextEvent;
+      cpuTotalTicks = 0;
+      cpuDmaHack = false;
     
-    cpuLoopTicks -= clockTicks;
-    if((cpuLoopTicks <= 0)) {
-      if(cpuSavedTicks) {
-        clockTicks = cpuSavedTicks;// + cpuLoopTicks;
+    updateLoop:
+
+      if (IRQTicks)
+      {
+          IRQTicks -= clockTicks;
+        if (IRQTicks<0)
+          IRQTicks = 0;
       }
-      cpuDmaTicksToUpdate = -cpuLoopTicks;
 
-    updateLoop:
       lcdTicks -= clockTicks;
+
       
       if(lcdTicks <= 0) {
         if(DISPSTAT & 1) { // V-BLANK
           // if in V-Blank mode, keep computing...
           if(DISPSTAT & 2) {
-            lcdTicks += 960;
+            lcdTicks += 1008;
             VCOUNT++;
             UPDATE_REG(0x06, VCOUNT);
             DISPSTAT &= 0xFFFD;
             UPDATE_REG(0x04, DISPSTAT);
             CPUCompareVCOUNT();
           } else {
-            lcdTicks += 272;
+            lcdTicks += 224;
             DISPSTAT |= 2;
             UPDATE_REG(0x04, DISPSTAT);
             if(DISPSTAT & 16) {
@@ -3453,7 +3936,7 @@
             }
           }
           
-          if(VCOUNT >= 228) {
+          if(VCOUNT >= 228) { //Reaching last line
             DISPSTAT &= 0xFFFC;
             UPDATE_REG(0x04, DISPSTAT);
             VCOUNT = 0;
@@ -3469,8 +3952,8 @@
             // if in H-Blank, leave it and move to drawing mode
             VCOUNT++;
             UPDATE_REG(0x06, VCOUNT);
-            
-            lcdTicks += (960);
+
+            lcdTicks += 1008;
             DISPSTAT &= 0xFFFD;
             if(VCOUNT == 160) {
               count++;
@@ -3518,10 +4001,9 @@
               }
               
               u32 ext = (joy >> 10);
-              int cheatTicks = 0;
-              if(cheatsEnabled)
-                cheatsCheckKeys(P1^0x3FF, ext);
-              cpuDmaTicksToUpdate += cheatTicks;
+              // If no (m) code is enabled, apply the cheats at each LCDline
+              if((cheatsEnabled) && (mastercode==0))
+                remainingTicks += cheatsCheckKeys(P1^0x3FF, ext);
               speedup = (ext & 1) ? true : false;
               capture = (ext & 2) ? true : false;
               
@@ -3530,7 +4012,7 @@
                 systemScreenCapture(captureNumber);
               }
               capturePrevious = capture;
-              
+
               DISPSTAT |= 1;
               DISPSTAT &= 0xFFFD;
               UPDATE_REG(0x04, DISPSTAT);
@@ -3549,14 +4031,14 @@
             }
             
             UPDATE_REG(0x04, DISPSTAT);
-            
-            CPUCompareVCOUNT(); 
+            CPUCompareVCOUNT();
+
           } else {
-            if(frameCount >= framesToSkip) {
-              (*renderLine)();
-              
+            if(frameCount >= framesToSkip) 
+            {
+              (*renderLine)(); 
               switch(systemColorDepth) {
-              case 16:
+                case 16:
                 {
                   u16 *dest = (u16 *)pix + 242 * (VCOUNT+1);
                   for(int x = 0; x < 240;) {
@@ -3584,7 +4066,7 @@
                   *dest++ = 0;
                 }
                 break;
-              case 24:
+                case 24:
                 {
                   u8 *dest = (u8 *)pix + 240 * VCOUNT * 3;
                   for(int x = 0; x < 240;) {
@@ -3626,7 +4108,7 @@
                   }
                 }
                 break;
-              case 32:
+                case 32:
                 {
                   u32 *dest = (u32 *)pix + 241 * (VCOUNT+1);
                   for(int x = 0; x < 240; ) {
@@ -3634,7 +4116,7 @@
                     *dest++ = systemColorMap32[lineMix[x++] & 0xFFFF];
                     *dest++ = systemColorMap32[lineMix[x++] & 0xFFFF];
                     *dest++ = systemColorMap32[lineMix[x++] & 0xFFFF];
-                    
+                 
                     *dest++ = systemColorMap32[lineMix[x++] & 0xFFFF];
                     *dest++ = systemColorMap32[lineMix[x++] & 0xFFFF];
                     *dest++ = systemColorMap32[lineMix[x++] & 0xFFFF];
@@ -3657,7 +4139,7 @@
             // entering H-Blank
             DISPSTAT |= 2;
             UPDATE_REG(0x04, DISPSTAT);
-            lcdTicks += 272;
+            lcdTicks += 224;
             CPUCheckDMA(2, 0x0f);
             if(DISPSTAT & 16) {
               IF |= 2;
@@ -3669,37 +4151,18 @@
 
       if(!stopState) {
         if(timer0On) {
-          if(timer0ClockReload == 1) {
-            u32 tm0d = TM0D + clockTicks;
-            if(tm0d > 0xffff) {
-              tm0d += timer0Reload;
-              timerOverflow |= 1;
-              soundTimerOverflow(0);
-              if(TM0CNT & 0x40) {
-                IF |= 0x08;
-                UPDATE_REG(0x202, IF);
-              }
-            }
-            TM0D = tm0d;
-            timer0Ticks = 0x10000 - TM0D;
-            UPDATE_REG(0x100, TM0D);            
-          } else {
-            timer0Ticks -= clockTicks;    
-            if(timer0Ticks <= 0) {
-              timer0Ticks += timer0ClockReload;
-              TM0D++;
-              if(TM0D == 0) {
-                TM0D = timer0Reload;
-                timerOverflow |= 1;
-                soundTimerOverflow(0);
-                if(TM0CNT & 0x40) {
-                  IF |= 0x08;
-                  UPDATE_REG(0x202, IF);
-                }
-              }
-              UPDATE_REG(0x100, TM0D);  
+          timer0Ticks -= clockTicks;
+          if(timer0Ticks <= 0) {
+            timer0Ticks += (0x10000 - timer0Reload) << timer0ClockReload;
+            timerOverflow |= 1;
+            soundTimerOverflow(0);
+            if(TM0CNT & 0x40) {
+              IF |= 0x08;
+              UPDATE_REG(0x202, IF);
             }
           }
+          TM0D = 0xFFFF - (timer0Ticks >> timer0ClockReload);
+          UPDATE_REG(0x100, TM0D);            
         }
         
         if(timer1On) {
@@ -3718,38 +4181,18 @@
               UPDATE_REG(0x104, TM1D);
             }
           } else {
-            if(timer1ClockReload == 1) {
-              u32 tm1d = TM1D + clockTicks;
-              if(tm1d > 0xffff) {
-                tm1d += timer1Reload;
-                timerOverflow |= 2;           
-                soundTimerOverflow(1);
-                if(TM1CNT & 0x40) {
-                  IF |= 0x10;
-                  UPDATE_REG(0x202, IF);
-                }
-              }
-              TM1D = tm1d;
-              timer1Ticks = 0x10000 - TM1D;
-              UPDATE_REG(0x104, TM1D);                    
-            } else {
-              timer1Ticks -= clockTicks;          
-              if(timer1Ticks <= 0) {
-                timer1Ticks += timer1ClockReload;
-                TM1D++;
-                
-                if(TM1D == 0) {
-                  TM1D = timer1Reload;
-                  timerOverflow |= 2;           
-                  soundTimerOverflow(1);
-                  if(TM1CNT & 0x40) {
-                    IF |= 0x10;
-                    UPDATE_REG(0x202, IF);
-                  }
-                }
-                UPDATE_REG(0x104, TM1D);        
+            timer1Ticks -= clockTicks;
+            if(timer1Ticks <= 0) {
+              timer1Ticks += (0x10000 - timer1Reload) << timer1ClockReload;
+              timerOverflow |= 2;           
+              soundTimerOverflow(1);
+              if(TM1CNT & 0x40) {
+                IF |= 0x10;
+                UPDATE_REG(0x202, IF);
               }
             }
+            TM1D = 0xFFFF - (timer1Ticks >> timer1ClockReload);
+            UPDATE_REG(0x104, TM1D); 
           }
         }
         
@@ -3768,36 +4211,17 @@
               UPDATE_REG(0x108, TM2D);
             }
           } else {
-            if(timer2ClockReload == 1) {
-              u32 tm2d = TM2D + clockTicks;
-              if(tm2d > 0xffff) {
-                tm2d += timer2Reload;
-                timerOverflow |= 4;
-                if(TM2CNT & 0x40) {
-                  IF |= 0x20;
-                  UPDATE_REG(0x202, IF);
-                }
-              }
-              TM2D = tm2d;
-              timer2Ticks = 0x10000 - TM2D;
-              UPDATE_REG(0x108, TM2D);                    
-            } else {
-              timer2Ticks -= clockTicks;          
-              if(timer2Ticks <= 0) {
-                timer2Ticks += timer2ClockReload;
-                TM2D++;
-                
-                if(TM2D == 0) {
-                  TM2D = timer2Reload;
-                  timerOverflow |= 4;
-                  if(TM2CNT & 0x40) {
-                    IF |= 0x20;
-                    UPDATE_REG(0x202, IF);
-                  }
-                }
-                UPDATE_REG(0x108, TM2D);        
+            timer2Ticks -= clockTicks;
+            if(timer2Ticks <= 0) {
+              timer2Ticks += (0x10000 - timer2Reload) << timer2ClockReload;
+              timerOverflow |= 4;           
+              if(TM2CNT & 0x40) {
+                IF |= 0x20;
+                UPDATE_REG(0x202, IF);
               }
             }
+            TM2D = 0xFFFF - (timer2Ticks >> timer2ClockReload);
+            UPDATE_REG(0x108, TM2D); 
           }
         }
         
@@ -3812,41 +4236,26 @@
                   UPDATE_REG(0x202, IF);
                 }
               }
-              UPDATE_REG(0x10c, TM3D);
+              UPDATE_REG(0x10C, TM3D);
             }
           } else {
-            if(timer3ClockReload == 1) {
-              u32 tm3d = TM3D + clockTicks;
-              if(tm3d > 0xffff) {
-                tm3d += timer3Reload;
-                if(TM3CNT & 0x40) {
-                  IF |= 0x40;
-                  UPDATE_REG(0x202, IF);
-                }
-              }
-              TM3D = tm3d;
-              timer3Ticks = 0x10000 - TM3D;
-              UPDATE_REG(0x10C, TM3D);                            
-            } else {
-              timer3Ticks -= clockTicks;          
-              if(timer3Ticks <= 0) {
-                timer3Ticks += timer3ClockReload;
-                TM3D++;
-                
-                if(TM3D == 0) {
-                  TM3D = timer3Reload;
-                  if(TM3CNT & 0x40) {
-                    IF |= 0x40;
-                    UPDATE_REG(0x202, IF);
-                  }
-                }
-                UPDATE_REG(0x10C, TM3D);
+              timer3Ticks -= clockTicks;
+            if(timer3Ticks <= 0) {
+              timer3Ticks += (0x10000 - timer3Reload) << timer3ClockReload;         
+              if(TM3CNT & 0x40) {
+                IF |= 0x40;
+                UPDATE_REG(0x202, IF);
               }
             }
+            TM3D = 0xFFFF - (timer3Ticks >> timer3ClockReload);
+            UPDATE_REG(0x10C, TM3D); 
           }
         }
       }
-      // we shouldn't be doing sound in stop state, but we lose synchronization
+
+      timerOverflow = 0;
+
+      // we shouldn't be doing sound in stop state, but we loose synchronization
       // if sound is disabled, so in stop state, soundTick will just produce
       // mute sound
       soundTicks -= clockTicks;
@@ -3854,33 +4263,40 @@
         soundTick();
         soundTicks += SOUND_CLOCK_TICKS;
       }
-      timerOverflow = 0;
 
 #ifdef PROFILING
       profilingTicks -= clockTicks;
       if(profilingTicks <= 0) {
         profilingTicks += profilingTicksReload;
-        if(profilBuffer && profilSize) {
-          u16 *b = (u16 *)profilBuffer;
-          int pc = ((reg[15].I - profilLowPC) * profilScale)/0x10000;
-          if(pc >= 0 && pc < profilSize) {
+        if(profilSegment) {
+	  profile_segment *seg = profilSegment;
+	  do {
+	    u16 *b = (u16 *)seg->sbuf;
+	    int pc = ((reg[15].I - seg->s_lowpc) * seg->s_scale)/0x10000;
+	    if(pc >= 0 && pc < seg->ssiz) {
             b[pc]++;
+	      break;
           }
+
+	    seg = seg->next;
+	  } while(seg);
         }
       }
 #endif
 
       ticks -= clockTicks;
 
-      cpuLoopTicks = CPUUpdateTicks();
+      cpuNextEvent = CPUUpdateTicks();
       
       if(cpuDmaTicksToUpdate > 0) {
-        clockTicks = cpuSavedTicks;
-        if(clockTicks > cpuDmaTicksToUpdate)
+        if(cpuDmaTicksToUpdate > cpuNextEvent)
+          clockTicks = cpuNextEvent;
+        else
           clockTicks = cpuDmaTicksToUpdate;
         cpuDmaTicksToUpdate -= clockTicks;
         if(cpuDmaTicksToUpdate < 0)
           cpuDmaTicksToUpdate = 0;
+        cpuDmaHack = true;
         goto updateLoop;
       }
 
